diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/sta-wifi-mac.cc ns-3.31/src/wifi/model/sta-wifi-mac.cc
--- ns-3.30.1/src/wifi/model/sta-wifi-mac.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/sta-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -88,6 +88,7 @@
 
 StaWifiMac::StaWifiMac ()
   : m_state (UNASSOCIATED),
+    m_aid (0),
     m_waitBeaconEvent (),
     m_probeRequestEvent (),
     m_assocRequestEvent (),
@@ -112,6 +113,13 @@
   NS_LOG_FUNCTION (this);
 }
 
+uint16_t
+StaWifiMac::GetAssociationId (void) const
+{
+  NS_ASSERT_MSG (IsAssociated (), "This station is not associated to any AP");
+  return m_aid;
+}
+
 void
 StaWifiMac::SetActiveProbing (bool enable)
 {
@@ -161,12 +169,12 @@
   MgtProbeRequestHeader probe;
   probe.SetSsid (GetSsid ());
   probe.SetSupportedRates (GetSupportedRates ());
-  if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+  if (GetHtSupported ())
     {
       probe.SetExtendedCapabilities (GetExtendedCapabilities ());
       probe.SetHtCapabilities (GetHtCapabilities ());
     }
-  if (GetVhtSupported () || GetHeSupported ())
+  if (GetVhtSupported ())
     {
       probe.SetVhtCapabilities (GetVhtCapabilities ());
     }
@@ -202,12 +210,12 @@
       assoc.SetSupportedRates (GetSupportedRates ());
       assoc.SetCapabilities (GetCapabilities ());
       assoc.SetListenInterval (0);
-      if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+      if (GetHtSupported ())
         {
           assoc.SetExtendedCapabilities (GetExtendedCapabilities ());
           assoc.SetHtCapabilities (GetHtCapabilities ());
         }
-      if (GetVhtSupported () || GetHeSupported ())
+      if (GetVhtSupported ())
         {
           assoc.SetVhtCapabilities (GetVhtCapabilities ());
         }
@@ -225,12 +233,12 @@
       reassoc.SetSupportedRates (GetSupportedRates ());
       reassoc.SetCapabilities (GetCapabilities ());
       reassoc.SetListenInterval (0);
-      if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+      if (GetHtSupported ())
         {
           reassoc.SetExtendedCapabilities (GetExtendedCapabilities ());
           reassoc.SetHtCapabilities (GetHtCapabilities ());
         }
-      if (GetVhtSupported () || GetHeSupported ())
+      if (GetVhtSupported ())
         {
           reassoc.SetVhtCapabilities (GetVhtCapabilities ());
         }
@@ -302,7 +310,7 @@
     case REFUSED:
       /* we have sent an association request and received a negative
          association response. We wait until someone restarts an
-         association with a given ssid.
+         association with a given SSID.
        */
       break;
     }
@@ -424,7 +432,7 @@
 }
 
 void
-StaWifiMac::Enqueue (Ptr<const Packet> packet, Mac48Address to)
+StaWifiMac::Enqueue (Ptr<Packet> packet, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << to);
   if (!IsAssociated ())
@@ -470,9 +478,9 @@
     {
       hdr.SetType (WIFI_MAC_DATA);
     }
-  if (GetQosSupported () || GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+  if (GetQosSupported ())
     {
-      hdr.SetNoOrder (); // explicitly set to 0 for the time being since HT/VHT/HE control field is not yet implemented (set it to 1 when implemented)
+      hdr.SetNoOrder (); // explicitly set to 0 for the time being since HT control field is not yet implemented (set it to 1 when implemented)
     }
 
   hdr.SetAddr1 (GetBssid ());
@@ -494,9 +502,11 @@
 }
 
 void
-StaWifiMac::Receive (Ptr<Packet> packet, const WifiMacHeader *hdr)
+StaWifiMac::Receive (Ptr<WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this << packet << hdr);
+  NS_LOG_FUNCTION (this << *mpdu);
+  const WifiMacHeader* hdr = &mpdu->GetHeader ();
+  Ptr<const Packet> packet = mpdu->GetPacket ();
   NS_ASSERT (!hdr->IsCtl ());
   if (hdr->GetAddr3 () == GetAddress ())
     {
@@ -539,7 +549,7 @@
           if (hdr->IsQosAmsdu ())
             {
               NS_ASSERT (hdr->GetAddr3 () == GetBssid ());
-              DeaggregateAmsduAndForward (packet, hdr);
+              DeaggregateAmsduAndForward (mpdu);
               packet = 0;
             }
           else
@@ -565,7 +575,8 @@
     {
       NS_LOG_DEBUG ("Beacon received");
       MgtBeaconHeader beacon;
-      packet->RemoveHeader (beacon);
+      Ptr<Packet> copy = packet->Copy ();
+      copy->RemoveHeader (beacon);
       CapabilityInformation capabilities = beacon.GetCapabilities ();
       NS_ASSERT (capabilities.IsEss ());
       bool goodBeacon = false;
@@ -620,7 +631,7 @@
         {
           NS_LOG_DEBUG ("Beacon received while scanning from " << hdr->GetAddr2 ());
           SnrTag snrTag;
-          bool removed = packet->RemovePacketTag (snrTag);
+          bool removed = copy->RemovePacketTag (snrTag);
           NS_ASSERT (removed);
           ApInfo apInfo;
           apInfo.m_apAddr = hdr->GetAddr2 ();
@@ -638,14 +649,15 @@
         {
           NS_LOG_DEBUG ("Probe response received while scanning from " << hdr->GetAddr2 ());
           MgtProbeResponseHeader probeResp;
-          packet->RemoveHeader (probeResp);
+          Ptr<Packet> copy = packet->Copy ();
+          copy->RemoveHeader (probeResp);
           if (!probeResp.GetSsid ().IsEqual (GetSsid ()))
             {
               NS_LOG_DEBUG ("Probe response is not for our SSID");
               return;
             }
           SnrTag snrTag;
-          bool removed = packet->RemovePacketTag (snrTag);
+          bool removed = copy->RemovePacketTag (snrTag);
           NS_ASSERT (removed);
           ApInfo apInfo;
           apInfo.m_apAddr = hdr->GetAddr2 ();
@@ -662,7 +674,7 @@
       if (m_state == WAIT_ASSOC_RESP)
         {
           MgtAssocResponseHeader assocResp;
-          packet->RemoveHeader (assocResp);
+          packet->PeekHeader (assocResp);
           if (m_assocRequestEvent.IsRunning ())
             {
               m_assocRequestEvent.Cancel ();
@@ -670,6 +682,7 @@
           if (assocResp.GetStatusCode ().IsSuccess ())
             {
               SetState (ASSOCIATED);
+              m_aid = assocResp.GetAssociationId ();
               if (hdr->IsReassocResp ())
                 {
                   NS_LOG_DEBUG ("reassociation done");
@@ -703,7 +716,7 @@
   //Invoke the receive handler of our parent class to deal with any
   //other frames. Specifically, this will handle Block Ack-related
   //Management Action frames.
-  RegularWifiMac::Receive (packet, hdr);
+  RegularWifiMac::Receive (Create<WifiMacQueueItem> (packet, *hdr));
 }
 
 void
@@ -833,7 +846,7 @@
             }
         }
     }
-  if (GetHtSupported () || GetVhtSupported ())
+  if (GetHtSupported ())
     {
       ExtendedCapabilities extendedCapabilities = beacon.GetExtendedCapabilities ();
       //TODO: to be completed
@@ -841,15 +854,17 @@
   if (GetHeSupported ())
     {
       HeCapabilities heCapabilities = beacon.GetHeCapabilities ();
-      //todo: once we support non constant rate managers, we should add checks here whether HE is supported by the peer
-      m_stationManager->AddStationHeCapabilities (apAddr, heCapabilities);
-      HeOperation heOperation = beacon.GetHeOperation ();
-      for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+      if (heCapabilities.GetSupportedMcsAndNss () != 0)
         {
-          WifiMode mcs = m_phy->GetMcs (i);
-          if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HE && heCapabilities.IsSupportedRxMcs (mcs.GetMcsValue ()))
+          m_stationManager->AddStationHeCapabilities (apAddr, heCapabilities);
+          HeOperation heOperation = beacon.GetHeOperation ();
+          for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
             {
-              m_stationManager->AddSupportedMcs (apAddr, mcs);
+              WifiMode mcs = m_phy->GetMcs (i);
+              if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HE && heCapabilities.IsSupportedRxMcs (mcs.GetMcsValue ()))
+                {
+                  m_stationManager->AddSupportedMcs (apAddr, mcs);
+                }
             }
         }
     }
@@ -1027,10 +1042,12 @@
   if (GetHeSupported ())
     {
       HeCapabilities hecapabilities = assocResp.GetHeCapabilities ();
-      //todo: once we support non constant rate managers, we should add checks here whether HE is supported by the peer
-      m_stationManager->AddStationHeCapabilities (apAddr, hecapabilities);
-      HeOperation heOperation = assocResp.GetHeOperation ();
-      GetHeConfiguration ()->SetAttribute ("BssColor", UintegerValue (heOperation.GetBssColor ()));
+      if (hecapabilities.GetSupportedMcsAndNss () != 0)
+        {
+          m_stationManager->AddStationHeCapabilities (apAddr, hecapabilities);
+          HeOperation heOperation = assocResp.GetHeOperation ();
+          GetHeConfiguration ()->SetAttribute ("BssColor", UintegerValue (heOperation.GetBssColor ()));
+        }
     }
   for (uint8_t i = 0; i < m_phy->GetNModes (); i++)
     {
@@ -1070,7 +1087,7 @@
             }
         }
     }
-  if (GetHtSupported () || GetVhtSupported ())
+  if (GetHtSupported ())
     {
       ExtendedCapabilities extendedCapabilities = assocResp.GetExtendedCapabilities ();
       //TODO: to be completed
@@ -1101,7 +1118,7 @@
       NS_LOG_DEBUG ("Adding supported rate of " << modeDataRate);
       rates.AddSupportedRate (modeDataRate);
     }
-  if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+  if (GetHtSupported ())
     {
       for (uint8_t i = 0; i < m_phy->GetNBssMembershipSelectors (); i++)
         {
@@ -1115,7 +1132,7 @@
 StaWifiMac::GetCapabilities (void) const
 {
   CapabilityInformation capabilities;
-  capabilities.SetShortPreamble (m_phy->GetShortPlcpPreambleSupported () || GetErpSupported ());
+  capabilities.SetShortPreamble (m_phy->GetShortPhyPreambleSupported () || GetErpSupported ());
   capabilities.SetShortSlotTime (GetShortSlotTimeSupported () && GetErpSupported ());
   if (GetPcfSupported ())
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/sta-wifi-mac.h ns-3.31/src/wifi/model/sta-wifi-mac.h
--- ns-3.30.1/src/wifi/model/sta-wifi-mac.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/sta-wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -45,7 +45,7 @@
 {
   Mac48Address m_bssid;               ///< BSSID
   Mac48Address m_apAddr;              ///< AP MAC address
-  double m_snr;                       ///< SNR
+  double m_snr;                       ///< SNR in linear scale
   bool m_activeProbing;               ///< Flag whether active probing is used or not
   MgtBeaconHeader m_beacon;           ///< Beacon header
   MgtProbeResponseHeader m_probeResp; ///< Probe Response header
@@ -132,11 +132,11 @@
    * \param packet the packet to send.
    * \param to the address to which the packet should be sent.
    *
-   * The packet should be enqueued in a tx queue, and should be
+   * The packet should be enqueued in a TX queue, and should be
    * dequeued as soon as the channel access function determines that
    * access is granted to this MAC.
    */
-  void Enqueue (Ptr<const Packet> packet, Mac48Address to);
+  void Enqueue (Ptr<Packet> packet, Mac48Address to);
 
   /**
    * \param phy the physical layer attached to this MAC.
@@ -150,6 +150,12 @@
    */
   bool IsAssociated (void) const;
 
+  /**
+   * Return the association ID.
+   *
+   * \return the association ID
+   */
+  uint16_t GetAssociationId (void) const;
 
 private:
   /**
@@ -181,10 +187,9 @@
   /**
    * Handle a received packet.
    *
-   * \param packet the received packet
-   * \param hdr the MAC header of the received packet
+   * \param mpdu the received MPDU
    */
-  void Receive (Ptr<Packet> packet, const WifiMacHeader *hdr);
+  void Receive (Ptr<WifiMacQueueItem> mpdu);
   /**
    * Update associated AP's information from beacon. If STA is not associated,
    * this information will used for the association process.
@@ -311,24 +316,25 @@
   void DoInitialize (void);
 
   MacState m_state;            ///< MAC state
+  uint16_t m_aid;              ///< Association AID
   Time m_waitBeaconTimeout;    ///< wait beacon timeout
   Time m_probeRequestTimeout;  ///< probe request timeout
-  Time m_assocRequestTimeout;  ///< assoc request timeout
+  Time m_assocRequestTimeout;  ///< association request timeout
   EventId m_waitBeaconEvent;   ///< wait beacon event
   EventId m_probeRequestEvent; ///< probe request event
-  EventId m_assocRequestEvent; ///< assoc request event
+  EventId m_assocRequestEvent; ///< association request event
   EventId m_beaconWatchdog;    ///< beacon watchdog
   Time m_beaconWatchdogEnd;    ///< beacon watchdog end
   uint32_t m_maxMissedBeacons; ///< maximum missed beacons
   bool m_activeProbing;        ///< active probing
-  std::vector<ApInfo> m_candidateAps; ///< list of candidate APs to associate
+  std::vector<ApInfo> m_candidateAps; ///< list of candidate APs to associate to
   // Note: std::multiset<ApInfo> might be a candidate container to implement
   // this sorted list, but we are using a std::vector because we want to sort
   // based on SNR but find duplicates based on BSSID, and in practice this
   // candidate vector should not be too large.
 
-  TracedCallback<Mac48Address> m_assocLogger;   ///< assoc logger
-  TracedCallback<Mac48Address> m_deAssocLogger; ///< deassoc logger
+  TracedCallback<Mac48Address> m_assocLogger;   ///< association logger
+  TracedCallback<Mac48Address> m_deAssocLogger; ///< disassociation logger
   TracedCallback<Time>         m_beaconArrival; ///< beacon arrival logger
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/supported-rates.cc ns-3.31/src/wifi/model/supported-rates.cc
--- ns-3.30.1/src/wifi/model/supported-rates.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/supported-rates.cc	2020-06-27 17:38:30.000000000 -0700
@@ -294,14 +294,6 @@
   return length;
 }
 
-/**
- * Serialize SupportedRates to the given ostream.
- *
- * \param os
- * \param rates
- *
- * \return std::ostream
- */
 std::ostream &operator << (std::ostream &os, const SupportedRates &rates)
 {
   os << "[";
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/supported-rates.h ns-3.31/src/wifi/model/supported-rates.h
--- ns-3.30.1/src/wifi/model/supported-rates.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/supported-rates.h	2020-06-27 17:38:30.000000000 -0700
@@ -47,62 +47,29 @@
    * Create an extended supported rates information element
    * from the given rates.
    *
-   * \param rates
+   * \param rates the extended supported rates
    */
   ExtendedSupportedRatesIE (SupportedRates *rates);
 
-  /**
-   * Set supported rates.
-   *
-   * \param rates the supported rates
-   */
-  void SetSupportedRates (SupportedRates *rates);
-
-  /**
-   * Get element ID.
-   * \returns the wifi information element ID
-   */
+  // Implementations of pure virtual methods of WifiInformationElement
   WifiInformationElementId ElementId () const;
-  /**
-   * Get information field size.
-   * \returns the information field size
-   */
   uint8_t GetInformationFieldSize () const;
-  /**
-   * Serialize information field.
-   *
-   * \param start the iterator
-   */
   void SerializeInformationField (Buffer::Iterator start) const;
-  /**
-   * Deserialize information field.
-   *
-   * \param start the iterator
-   * \param length the field length (bytes)
-   * \returns length of the information field deserialized (bytes)
-   */
   uint8_t DeserializeInformationField (Buffer::Iterator start,
                                        uint8_t length);
-
-  /**
-   * This information element is a bit special in that it is only
-   * included if there are more than 8 rates. To support this we
-   * override the Serialize and GetSerializedSize methods of
-   * WifiInformationElement.
-   *
-   * \param start
-   *
-   * \return an iterator
-   */
+  /* This information element is a bit special in that it is only
+    included if there are more than 8 rates. To support this we
+    override the Serialize and GetSerializedSize methods of
+    WifiInformationElement. */
   Buffer::Iterator Serialize (Buffer::Iterator start) const;
+  uint16_t GetSerializedSize () const;
+
   /**
-   * Return the serialized size of this supported rates
-   * information element.
+   * Set supported rates.
    *
-   * \return the serialized size of this supported rates
-   *         information element
+   * \param rates the supported rates
    */
-  uint16_t GetSerializedSize () const;
+  void SetSupportedRates (SupportedRates *rates);
 
 
 private:
@@ -132,6 +99,14 @@
 
   /// type conversion operator
   SupportedRates (const SupportedRates &);
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const;
+  uint8_t GetInformationFieldSize () const;
+  void SerializeInformationField (Buffer::Iterator start) const;
+  uint8_t DeserializeInformationField (Buffer::Iterator start,
+                                       uint8_t length);
+
   /**
    * assignment operator
    *
@@ -140,24 +115,24 @@
    */
   SupportedRates& operator= (const SupportedRates& rates);
 
-/**
- * This defines the maximum number of supported rates that a STA is
- * allowed to have. Currently this number is set for IEEE 802.11b/g and SISO IEEE 802.11n
- * stations which need 2 rates each from Clauses 15 and 18, and then 8
- * from Clause 19.
- */
+  /**
+   * This defines the maximum number of supported rates that a STA is
+   * allowed to have. Currently this number is set for IEEE 802.11b/g and SISO IEEE 802.11n
+   * stations which need 2 rates each from Clauses 15 and 18, and then 8
+   * from Clause 19.
+   */
   static const uint8_t MAX_SUPPORTED_RATES = 32;
 
   /**
    * Add the given rate to the supported rates.
    *
-   * \param bs the rate to be added
+   * \param bs the rate to be added in bps
    */
   void AddSupportedRate (uint64_t bs);
   /**
    * Set the given rate to basic rates.
    *
-   * \param bs the rate to be set
+   * \param bs the rate to be set in bps
    */
   void SetBasicRate (uint64_t bs);
   /**
@@ -172,7 +147,7 @@
    * serialized to the Supported Rates Information Element (i.e. as a
    * multiple of 500 Kbits/sec, possibly with MSB set to 1).
    *
-   * \param bs the rate to be checked
+   * \param bs the rate to be checked in bps
    *
    * \return true if the rate is supported, false otherwise
    */
@@ -182,7 +157,7 @@
    * serialized to the Supported Rates Information Element (i.e. as a
    * multiple of 500 Kbits/sec, with MSB set to 1).
    *
-   * \param bs the rate to be checked
+   * \param bs the rate to be checked in bps
    *
    * \return true if the rate is a basic rate, false otherwise
    */
@@ -192,7 +167,7 @@
    * is encoded as it is serialized to the Supporting Rates Information
    * Element (i.e. with the MSB set to 1).
    *
-   * \param bs the rate to be checked
+   * \param bs the rate to be checked in bps
    *
    * \return true if the rate is a BSS membership selector, false otherwise
    */
@@ -208,36 +183,9 @@
    * Return the rate (converted back to raw value) at the given index.
    *
    * \param i the given index
-   * \return the rate
+   * \return the rate in bps
    */
   uint32_t GetRate (uint8_t i) const;
-  /**
-   * Get the ElementID.
-   *
-   * \returns the element ID
-   */
-  WifiInformationElementId ElementId () const;
-  /**
-   * Get the information field size.
-   *
-   * \returns the information field size
-   */
-  uint8_t GetInformationFieldSize () const;
-  /**
-   * Get the information field size.
-   *
-   * \param start the information field iterator
-   */
-  void SerializeInformationField (Buffer::Iterator start) const;
-  /**
-   * Get the information field size.
-   *
-   * \param start the information field iterator
-   * \param length the size of the information field (bytes)
-   * \returns the size of the field read (bytes)
-   */
-  uint8_t DeserializeInformationField (Buffer::Iterator start,
-                                       uint8_t length);
 
   /**
    * We support the Extended Supported Rates Information Element
@@ -252,9 +200,17 @@
 
 private:
   uint8_t m_nRates;                      //!< Number of supported rates
-  uint8_t m_rates[MAX_SUPPORTED_RATES];  //!< List of supported bitrate (divided by 500000)
+  uint8_t m_rates[MAX_SUPPORTED_RATES];  //!< List of supported bit rates (divided by 500000)
 };
 
+/**
+ * Serialize SupportedRates to the given ostream.
+ *
+ * \param os output stream
+ * \param rates the SupportedRates
+ *
+ * \return std::ostream
+ */
 std::ostream &operator << (std::ostream &os, const SupportedRates &rates);
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/threshold-preamble-detection-model.h ns-3.31/src/wifi/model/threshold-preamble-detection-model.h
--- ns-3.30.1/src/wifi/model/threshold-preamble-detection-model.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/threshold-preamble-detection-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -47,7 +47,7 @@
    * This method returns whether the preamble detection was successful.
    *
    * \param rssi the RSSI of the received signal (in Watts).
-   * \param snr the SNR ratio (not dB) of the received signal.
+   * \param snr the SNR ratio (linear scale) of the received signal.
    * \param channelWidth the channel width of the received signal in MHz.
    *
    * \return true if the preamble has been detected,
@@ -58,7 +58,7 @@
 
 private:
   double m_threshold; ///< SNR threshold in dB used to decide whether a preamble is successfully received
-  double m_rssiMin;   ///< Minimum RSSI that shall be received to start the decision
+  double m_rssiMin;   ///< Minimum RSSI in dBm that shall be received to start the decision
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/txop.cc ns-3.31/src/wifi/model/txop.cc
--- ns-3.30.1/src/wifi/model/txop.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/txop.cc	2020-06-27 17:38:30.000000000 -0700
@@ -29,6 +29,7 @@
 #include "mac-tx-middle.h"
 #include "mac-low.h"
 #include "wifi-remote-station-manager.h"
+#include "wifi-mac-trailer.h"
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT if (m_low != 0) { std::clog << "[mac=" << m_low->GetAddress () << "] "; }
@@ -304,16 +305,26 @@
   return m_txopLimit;
 }
 
+bool
+Txop::HasFramesToTransmit (void)
+{
+  bool ret = (m_currentPacket != 0 || !m_queue->IsEmpty ());
+  NS_LOG_FUNCTION (this << ret);
+  return ret;
+}
+
 void
-Txop::Queue (Ptr<const Packet> packet, const WifiMacHeader &hdr)
+Txop::Queue (Ptr<Packet> packet, const WifiMacHeader &hdr)
 {
   NS_LOG_FUNCTION (this << packet << &hdr);
-  Ptr<Packet> packetCopy = packet->Copy ();
   // remove the priority tag attached, if any
   SocketPriorityTag priorityTag;
-  packetCopy->RemovePacketTag (priorityTag);
-  m_stationManager->PrepareForQueue (hdr.GetAddr1 (), &hdr, packetCopy);
-  m_queue->Enqueue (Create<WifiMacQueueItem> (packetCopy, hdr));
+  packet->RemovePacketTag (priorityTag);
+  if (m_channelAccessManager->NeedBackoffUponAccess (this))
+    {
+      GenerateBackoff ();
+    }
+  m_queue->Enqueue (Create<WifiMacQueueItem> (packet, hdr));
   StartAccessIfNeeded ();
 }
 
@@ -363,9 +374,7 @@
   NS_LOG_FUNCTION (this);
   ResetCw ();
   m_cwTrace = GetCw ();
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
 }
 
 bool
@@ -524,12 +533,8 @@
         }
       else
         {
-          WifiTxVector dataTxVector = m_stationManager->GetDataTxVector (m_currentHdr.GetAddr1 (),
-                                                                         &m_currentHdr, m_currentPacket);
-
-          if (m_stationManager->NeedRts (m_currentHdr.GetAddr1 (), &m_currentHdr,
-                                         m_currentPacket, dataTxVector)
-              && !m_low->IsCfPeriod ())
+          uint32_t size = m_currentHdr.GetSize () + m_currentPacket->GetSize () + WIFI_MAC_FCS_LENGTH;
+          if (m_stationManager->NeedRts (m_currentHdr, size) && !m_low->IsCfPeriod ())
             {
               m_currentParams.EnableRts ();
             }
@@ -545,19 +550,19 @@
 }
 
 void
-Txop::NotifyInternalCollision (void)
+Txop::GenerateBackoff (void)
 {
   NS_LOG_FUNCTION (this);
-  NotifyCollision ();
+  m_backoff = m_rng->GetInteger (0, GetCw ());
+  m_backoffTrace (m_backoff);
+  StartBackoffNow (m_backoff);
 }
 
 void
-Txop::NotifyCollision (void)
+Txop::NotifyInternalCollision (void)
 {
   NS_LOG_FUNCTION (this);
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -615,7 +620,7 @@
         {
           m_txFailedCallback (m_currentHdr);
         }
-      //to reset the dcf.
+      //to reset the Txop.
       m_currentPacket = 0;
       ResetCw ();
       m_cwTrace = GetCw ();
@@ -625,9 +630,7 @@
       UpdateFailedCw ();
       m_cwTrace = GetCw ();
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -650,9 +653,7 @@
       m_currentPacket = 0;
       ResetCw ();
       m_cwTrace = GetCw ();
-      m_backoff = m_rng->GetInteger (0, GetCw ());
-      m_backoffTrace (m_backoff);
-      StartBackoffNow (m_backoff);
+      GenerateBackoff ();
       RestartAccessIfNeeded ();
     }
   else
@@ -675,7 +676,7 @@
         {
           m_txFailedCallback (m_currentHdr);
         }
-      //to reset the dcf.
+      //to reset the Txop.
       m_currentPacket = 0;
       ResetCw ();
       m_cwTrace = GetCw ();
@@ -689,9 +690,7 @@
       UpdateFailedCw ();
       m_cwTrace = GetCw ();
     }
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   RestartAccessIfNeeded ();
 }
 
@@ -772,9 +771,7 @@
   m_currentPacket = 0;
   ResetCw ();
   m_cwTrace = GetCw ();
-  m_backoff = m_rng->GetInteger (0, GetCw ());
-  m_backoffTrace (m_backoff);
-  StartBackoffNow (m_backoff);
+  GenerateBackoff ();
   if (!m_txOkCallback.IsNull ())
     {
       m_txOkCallback (m_currentHdr);
@@ -873,7 +870,7 @@
 }
 
 void
-Txop::GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, WifiMode txMode, double dataSnr)
+Txop::GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, double dataSnr, WifiTxVector dataTxVector)
 {
   NS_LOG_WARN ("GotBlockAck should not be called for non QoS!");
 }
